// USART1 extension for ATmega328PB with WinAVR-20100110
// 
// edit <install path>\WinAVR-20100110\avr\include\avr\iom328p.h, line 814
//
// in my case - C:\ProgramFiles\WinAVR-20100110\avr\include\avr\iom328p.h
//
// change #define _VECTORS_SIZE (26 * 4)
//     to #define _VECTORS_SIZE (31 * 4)
//
// then insert lines 19..23 (below) after vector 25 in iom328p.h

#ifndef	_ATMEGA_328PB_USART1_H_
#define _ATMEGA_328PB_USART1_H_

#define PRUSART1 4										// within PRR0 _SFR_MEM8(0x64)

#if 0
// start
#define NULL1							_VECTOR(26)
#define NULL2							_VECTOR(27)
#define USART1_RX_vect		_VECTOR(28)	/* USART1 Rx Complete */
#define USART1_UDRE_vect	_VECTOR(29)	/* USART1, Data Register Empty */
#define USART1_TX_vect		_VECTOR(30)	/* USART1 Tx Complete */
// end
#endif

#define UCSR1A  _SFR_MEM8(0xC8)
#define MPCM1   0
#define U2X1    1
#define UPE1    2
#define DOR1    3
#define FE1     4
#define UDRE1   5
#define TXC1    6
#define RXC1    7

#define UCSR1B  _SFR_MEM8(0xC9)
#define TXB81   0
#define RXB81   1
#define UCSZ12  2
#define TXEN1   3
#define RXEN1   4
#define UDRIE1  5
#define TXCIE1  6
#define RXCIE1  7

#define UCSR1C  _SFR_MEM8(0xCA)
#define UCPOL1  0
#define UCSZ10  1
#define UCSZ11  2
#define USBS1   3
#define UPM10   4
#define UPM11   5
#define UMSEL10 6
#define UMSEL11 7

// 0xCB reserved

#define UBRR1   _SFR_MEM16(0xCC)		/* Combine UBRR1L and UBRR1H */
#define UBRR1L  _SFR_MEM8(0xCC)
#define UBRR1H  _SFR_MEM8(0xCD)
#define UDR1    _SFR_MEM8(0xCE)			// Datasheet says 0xC7, which is wrong !

// 0xCF reserved

#endif
